#include "mUpPile.h"
#include "getRef.h"
#include <fstream>
#include "ctype.h"

int resID =0;

int refToInt[256] = {
  0,1,2,3,4,4,4,4,4,4,4,4,4,4,4,4,//15
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//31
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//47
  0,1,2,3,4,4,4,4,4,4,4,4,4,4,4,4,//63
  4,0,4,1,4,4,4,2,4,4,4,4,4,4,4,4,//79
  4,4,4,4,3,4,4,4,4,4,4,4,4,4,4,4,//95
  4,0,4,1,4,4,4,2,4,4,4,4,4,4,4,4,//111
  4,4,4,4,3,4,4,4,4,4,4,4,4,4,4,4,//127
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//143
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//159
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//175
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//191
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//207
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//223
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//239
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4//255
};

//this is stuped a=0,1=c,2=t,3=g
int refToIntSoap[256] = {
  0,1,3,2,4,4,4,4,4,4,4,4,4,4,4,4,//15
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//s1
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//47
  0,1,3,2,4,4,4,4,4,4,4,4,4,4,4,4,//6s
  4,0,4,1,4,4,4,3,4,4,4,4,4,4,4,4,//79
  4,4,4,4,2,4,4,4,4,4,4,4,4,4,4,4,//95
  4,0,4,1,4,4,4,3,4,4,4,4,4,4,4,4,//111
  4,4,4,4,2,4,4,4,4,4,4,4,4,4,4,4,//127
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//14s
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//159
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//175
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//191
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//207
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//22s
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//239
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4//255
};

#include <cmath>

int conv[4] = {0,1,3,2};

void make_p_prior(double het_novel_r,double althom_novel_r,int transition_dominant){
  double p_prior[8][4][4];
  for(int i=0;i<8;i++)
    for(int j=0;j<4;j++)
      for (int n=0;n<4;n++)
	p_prior[i][j][n] = 1;
  char t_base, allele1, allele2;
  // Note, the above parameter should be changed to a more reasonable one
  for(t_base=0;t_base!=4;t_base++) {
    for(allele1=0;allele1!=4;allele1++) {
      for(allele2=allele1;allele2!=4;allele2++) {
	if(allele1 == t_base && allele2 == t_base) {
	  // refHOM
	  p_prior[t_base][allele1][allele2] = 1;
	}
	else if (allele1 == t_base || allele2 == t_base) {
	  // refHET: 1 ref 1 alt
	  p_prior[t_base][allele1][allele2] = het_novel_r;
	}
	else if (allele1 == allele2) {
	  // altHOM
	  p_prior[t_base][allele1][allele2] = althom_novel_r;
	}
	else {
	  // altHET: 2 diff alt base
	  p_prior[t_base][allele1][allele2] = het_novel_r * althom_novel_r;
	}
	if( transition_dominant && ((allele1^t_base) == 0x3 || (allele2^t_base) == 0x3)) {
	  // transition
	  p_prior[t_base][allele1][allele2] *= 4;
	}
	//std::cerr<<"ACTG"[t_base]<<"\t"<<"ACTG"[allele1]<<"ACTG"[allele2]<<"\t"<<p_prior[t_base<<4|allele1<<2|allele2]<<endl;
      }
    }
  }
  for(allele1=0;allele1!=4;allele1++) {
    for(allele2=allele1;allele2!=4;allele2++) {
      // Deal with N
      p_prior[4][allele1][allele2] = (allele1==allele2? 1: (2*het_novel_r)) * 0.25 *0.25;
      p_prior[5][allele1][allele2] = (allele1==allele2? 1: (2*het_novel_r)) * 0.25 *0.25;
      p_prior[6][allele1][allele2] = (allele1==allele2? 1: (2*het_novel_r)) * 0.25 *0.25;
      p_prior[7][allele1][allele2] = (allele1==allele2? 1: (2*het_novel_r)) * 0.25 *0.25;
    }
  }
  if(1){
    FILE *fp = fopen("p_prior.txt","w");
    for(int i=0;i<8;i++){
      fprintf(fp,"%d",i);
      for(int j=0;j<4;j++)
	for(int n=0;n<4;n++)
	  fprintf(fp,"\t%f",log(p_prior[i][j][n]));
      fprintf(fp,"\n");
    }
    fclose(fp);
  }
}
#define LENS 100000
int getPmat(void *ret){
  int qchar_max = 41;
  int read_len = 100;
  double p_matrix[qchar_max][read_len][4][4];
  FILE *fp = fopen("qual.txt","r");
  char buf[LENS];
  
  for(int i=0;i<qchar_max;i++){
    for(int j=0;j<100;j++){
      fgets(buf,LENS,fp);
      for(int al1=3;al1>=0;al1--)
	for(int al2=3;al2>=0;al2--)
	  if(al1==al2 && al1==3)
	    p_matrix[i][j][al1][al2 ] = atof(strtok(buf,"\t \n"));
	  else
	    p_matrix[i][j][al1][al2 ] = atof(strtok(NULL,"\t \n"));
    }
    
  }
  ret = p_matrix;
  return 1;
}



void count_qual(size_t count_matrix[256][256][4][4], int q_min,int q_max,int read_length) {
  static double p_matrix[256][256][4][4];
  //  size_t coord;
  size_t o_base/*o_based base*/;
  size_t t_base/*theorecical(supposed) base*/;
  size_t sum[4];
  size_t  same_qual_count_by_type[4][4];// = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
  size_t  same_qual_count_by_t_base[4];// = {0,0,0,0};
  size_t  same_qual_count_total;
  size_t  same_qual_count_mismatch;
  
  const size_t sta_pow=10; // minimum number to say statistically powerful
  for(int q_char=q_min; q_char<=q_max ;q_char++)  {
    memset(same_qual_count_by_t_base,0,sizeof(size_t)*4);
    for(int i=0;i<4;i++)
      memset(same_qual_count_by_type[i],0,sizeof(size_t)*4);



    
    same_qual_count_total = 0;
    same_qual_count_mismatch = 0;
    for(int coord=0; coord != read_length ; coord++) {
      for(int t1=0;t1<4;t1++)
        for(int t2=0;t2<4;t2++){
          // If the sample is small, then we will not consider the effect of read cycle.
          same_qual_count_by_type[t1][t2] += count_matrix[q_char][coord][t1][t2];
          same_qual_count_by_t_base[t1] += count_matrix[q_char][coord][t1][t2];
          same_qual_count_total += count_matrix[q_char][coord][t1][t2];
	  //cerr<<(int)type<<'\t'<<same_qual_count_by_type[type]<<'\t'<<same_qual_count_by_t_base[0]<<endl;
          if(t1!= t2) 
	    // Mismatches
	    same_qual_count_mismatch += count_matrix[q_char][coord][t1][t2 ];
        
        }
    }
    //    fprintf(stderr,"[%d] same_qual_count_mismatch=%lu\n",q_char,same_qual_count_mismatch);
    for(int i=0;0&&i<4;i++)
      fprintf(stderr,"type[%d]=%lu\n",i,same_qual_count_by_t_base[conv[i]]);
    //      for(int j=0;0&j<4;j++)
	//	fprintf(stderr,"[%d][%d]=%lu\n",i,j,same_qual_count_by_type[i][j]);
	//	fprintf(stderr,"[%d][%d]=%lu\n",i,j,same_qual_count_by_type[conv[i]][conv[j]]);

    //    exit(0);
    for(int coord=0; coord != read_length ; coord++) {
      //      fprintf(stderr,"coord=%d\n",coord);
      //cerr<<(q_char)<<'\t'<<coord;
      memset(sum, (size_t)0, sizeof(size_t)*4);
      // Count of all ref base at certain coord and quality
      for(int t1=0;t1<4;t1++)
        for(int t2=0;t2<4;t2++)
          sum[t1] += count_matrix[q_char][coord][t1][t2]; // (type>>2)&3: the ref base

      if(0){
	if((sum[0]+sum[1]+sum[2]+sum[3])!=0){
	  fprintf(stderr,"yoyo\t%d %d\t",q_char,coord);
	  for(int i=0;i<4;i++)
	    fprintf(stderr,"%lu\t",sum[conv[i]]);
	fprintf(stderr,"\n");
	}
      }
      //cerr<<sum[type&3]<<endl;
      //      fprintf(stderr,"berore last %d %d\n",q_char,coord);
      for(t_base=0; t_base!=4; t_base++) {
        for(o_base=0; o_base!=4; o_base++) {
	  //	  fprintf(stderr,"t_base=%lu o_base=%lu same_qual_count_by_type[t_base][o_base]=%lu \n",t_base,o_base,same_qual_count_by_type[t_base][o_base]);
          //cerr<<'\t'<<count_matrix[ ((size_t)q_char<<12) | (coord <<4) | (t_base<<2) | o_base];
          if (count_matrix[ q_char][coord ][t_base][ o_base] > sta_pow) {
	    //	    fprintf(stderr,"bigpower\n");
            // Statistically powerful
            p_matrix[q_char][coord][ t_base][ o_base] = ((double)count_matrix[q_char][coord][t_base][ o_base]) /((double) sum[t_base]);
          }
          else if (same_qual_count_by_type[t_base][o_base] > sta_pow) {
	    //	    fprintf(stderr,"smallpower\n");
            // Smaller sample, given up effect from read cycle
            p_matrix [q_char][coord ][t_base][o_base] =  ((double)same_qual_count_by_type[t_base][o_base]) /((double) same_qual_count_by_t_base[t_base]);
          }
          else if (same_qual_count_total > 0){
	    //	    fprintf(stderr,"smallerst\n");
            // Too small sample, given up effect of mismatch types
            if (o_base == t_base) {
	      //fprintf(stderr,"notHEre\n");
              p_matrix [q_char][coord ][t_base][o_base] = ((double)(same_qual_count_total-same_qual_count_mismatch))/((double)same_qual_count_total);
            }
            else {
	      //	      fprintf(stderr," is tHEre\n");
              p_matrix [q_char][coord ][t_base][o_base] = ((double)same_qual_count_mismatch)/same_qual_count_total;
            }
          }
          else {
            ;
          }
	  //	  fprintf(stderr,"PRERES=%f\n",p_matrix [q_char][coord ][t_base][o_base]);          
          // For these cases like:
          // Ref: G o_base: G x10 Ax5. When calculate the probability of this allele to be A,
          // If there's no A in reference gives observation of G, then the probability will be zero,
          // And therefore exclude the possibility of this pos to have an A
          // These cases should be avoid when the dataset is large enough
          // If no base with certain quality is o_based, it also doesn't matter

          if( (p_matrix [q_char][coord ][t_base][o_base]==0) || (p_matrix [q_char][coord ][t_base][o_base] ==1)) {
	    //	    fprintf(stderr,"strange cases\n");
            if (o_base == t_base) {
              p_matrix [q_char][coord][t_base][o_base] = (1-pow(10, -((q_char-q_min)/10.0)));
	      //	      fprintf(stderr,"eq= %f\n", (1-pow(10, -((q_char-q_min)/10.0))));
              if(p_matrix [q_char][coord ][t_base][o_base]<0.25) {
                p_matrix [q_char][coord][t_base][o_base] = 0.25;
              }
            }
            else {
              p_matrix [q_char][coord ][t_base][o_base] = (pow(10, -((q_char-q_min)/10.0))/3);
	      //	      fprintf(stderr,"neq= %f\n", (pow(10, -((q_char-q_min)/10.0))/3));
              if(p_matrix [q_char][coord ][t_base][ o_base]>0.25) {
                p_matrix [q_char][coord][t_base][ o_base] = 0.25;
              }
            }
          }
	  if(0){
	    if(resID<100)
	    fprintf(stderr,"res[%d]=%f\n",resID,p_matrix [q_char][coord][t_base][ o_base]);
	    else{
	      fflush(stderr);
	      exit(0);
	    }
	    resID++;
	  }
        }
      }
      //      break;
      //      if(coord==5&&1)
      //	break;

      //      break;
    }
    //    break;
    //    break;
    //cerr<<'\t'<<same_qual_count_by_type[0]<<'\t'<<same_qual_count_by_t_base[0]<<endl;
  }
  if(0){  
    FILE *fp=fopen("temp2.txt","w");
    for(int qc = q_min;qc<=q_max;qc++) {
      for(int i=0;i<read_length;i++){
	fprintf(fp,"%d\t%d\t",qc-q_min,i);
	for(int a1=0;a1<4;a1++){
	  for(int a2=0;a2<4;a2++)
	    fprintf(fp,"%f\t",p_matrix[qc][i][a1][a2]);
	}
      fprintf(fp,"\n");
      }
    }
  }
  else {
    std::fstream fp;
    fp.open("temp2.txt",std::fstream::out);
    for(int qc = q_min;qc<=q_max;qc++) {
      for(int i=0;i<read_length;i++) {
	fp<< qc-q_min << '\t' << i;
	for(int a1=0;a1<4;a1++)
	  for(int a2=0;a2<4;a2++)
	    fp << '\t' << p_matrix[qc][i][conv[a1]][conv[a2]];
      fp << std::endl;
      }
    }
    fp.close();
  }
  make_p_prior(0.0001,0.00005,0);
}
 


void doTest(){
  char cAl[4] = {'A','C','T','G'};
  for(int i=0;i<4;i++)
    fprintf(stderr,"char=%c ascii=%d b1=%d b2=%d\n",cAl[i],cAl[i],(cAl[i]>>1)&3,(i&0x3)<<2 );
  
  fprintf(stderr,"----------\n");
  int id=0;
  for(int i=0;i<4;i++)
    for(int j=0;j<4;j++){
      int idInner = id++;
      fprintf(stderr,"[%d] geno=%c%c\tmod5=%d quest=%d\n",idInner,cAl[i],cAl[j],idInner %5,(idInner>>2)&3 );
    }
  
  exit(0);
}


void make_prob(chunkyT *chk) {
  int readLen=100;
  int qmin=64;
  int qmax=104;//inclusize
  //  doTest();



  //qs,seqpos,ref,nuc
  int printOrder[4] = {0,1,3,2};
  static size_t count_matrix[256][256][4][4];
  static int actuallyrun =0;
  if(chk==NULL){
    fprintf(stderr,"actuallyrun=%d\n",actuallyrun);
    FILE *fpp = fopen("temp.txt","w");
    for(int i=0;i<256;i++){
      for(int n=0;n<256;n++){
        fprintf(fpp,"%d\t%d\t",i, n);
        for(int a1=0;a1<4;a1++)
          for(int a2=0;a2<4;a2++)
            fprintf(fpp,"%lu\t",count_matrix[i][n][printOrder[a1]][printOrder[a2]]);
        fprintf(fpp,"\n");
      }
    }
    fclose(fpp);
    count_qual(count_matrix,qmin,qmax,readLen);
    return;
  }



  //  static int actuallyrun =0;
  char *refs = getRef1(chk,"/home/albrecht/bin/bwa-0.6.1/ref/hg19.fa");
  FILE *fp = stdout;
  int i=0;
  actuallyrun += chk->nSites;
  //      fprintf(stderr,"seqlen[%d,%d]=%lu\t",s,i,chk->nd[s][i].seq->l);
  for(int s=0;s<chk->nSites;s++){
    if(chk->nd[s][i].l!=0){
      fprintf(fp,"%d\t",chk->nd[s][i].refPos);
      fprintf(fp,"ref=%c\t",refs[s]);
      for(int l=0;l<chk->nd[s][i].l;l++)
        fprintf(fp,"%c",chk->nd[s][i].seq[l]);
      fprintf(fp,"\t");
      for(int l=0;l<chk->nd[s][i].l;l++)
        fprintf(fp,"%d",chk->nd[s][i].qs[l]+33);
      fprintf(fp,"\t");
      for(int l=0;l<chk->nd[s][i].l;l++){
        fprintf(fp,"%d:%d",chk->nd[s][i].posi[l],chk->nd[s][i].isop[l]);
      }
      
    }else
      fprintf(fp,"\t0\t*\t*");
    fprintf(fp,"\n");

    if(refs[s]=='n'||refs[s]=='N'){
      //      fprintf(stderr,"ref is n\n");
      continue;
    }for(int l=0;l<chk->nd[s][i].l;l++){
      char nuc = chk->nd[s][i].seq[l];
      //      fprintf(stderr,"nuc=%c\n",nuc);
      if(nuc =='n' || nuc=='N'){
        //fprintf(stderr,"soap is n\n");
        //      fflush(stderr);
        continue;
      }
      /*
        increment:
        [qs][position in read][reference][nucleotide]
      */
      if(isupper(nuc)){
        //fprintf(stderr,"[%d][%d][%d][%d]\n",(int)chk->nd[s][i].qs[l]+33,chk->nd[s][i].posi[l],refToInt[refs[s]],refToInt[chk->nd[s][i].seq[l]]);
        count_matrix[chk->nd[s][i].qs[l]+33] [chk->nd[s][i].posi[l]] [refToInt[refs[s]]] [refToInt[chk->nd[s][i].seq[l]]]++;
      }else{
        //      fprintf(stderr,"[%d][%d][%d][%d]\n",(int)chk->nd[s][i].qs[l]+33,chk->nd[s][i].isop[l],refToInt[refs[s]],refToInt[chk->nd[s][i].seq[l]]);
        count_matrix[chk->nd[s][i].qs[l]+33][chk->nd[s][i].isop[l]][refToInt[refs[s]]][refToInt[chk->nd[s][i].seq[l]]]++;
      }
    }


  }

}
